=== debian/changelog ===
docker.io (18.03.1+dfsg1-2) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * Upload to unstable.
  * Un-bundle "googleapis-gnostic-dev" and "docker-notary-dev".
  * Removed "golang-github-hashicorp-consul-dev" from Build-Depends.

  [ Arnaud Rebillout ]
  * Fix bash completion install.
  * d/control: depend on golang-any.
  * d/README.source: re-write part about docker-ce upstream workflow.
  * Set required version for imdario-mergo and hashicorp-memberlist.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 20 Jun 2018 23:40:47 +1000

docker.io (18.03.1+dfsg-1) experimental; urgency=medium

  * New upstream release [April 2018].
  * rules:
    + properly pass daemon version.
    + re-work override_dh_auto_configure with important fixes.
  * New patch to disable unreliable TestAdapterReadLogs.
  * Use packaged "tini", don't build it.
    Thanks, Arnaud Rebillout.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 19 Jun 2018 13:43:57 +1000

docker.io (17.12.1+dfsg-4) experimental; urgency=medium

  * golang-github-docker-docker-dev:
    + install only selected "libnetwork" components.
    + install missing "docker/cli" components.
    + install "docker/docker/cli".

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 18 Jun 2018 19:32:51 +1000

docker.io (17.12.1+dfsg-3) experimental; urgency=medium

  * Removed versioning from -dev Breaks/Replaces: libnetwork-dev
    (Closes: #901694).
  * Build with consistent tags "apparmor seccomp selinux ambient"
    (Closes: #901743).
    Thanks, Laurent Bigonville.
  * New patch to fix FTBFS on mips* architectures.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 18 Jun 2018 12:05:10 +1000

docker.io (17.12.1+dfsg-2) experimental; urgency=medium

  * New patch to disable TestGetRootUIDGID, failing in sbuild.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 16 Jun 2018 21:31:51 +1000

docker.io (17.12.1+dfsg-1) experimental; urgency=medium

  * Team upload.
  * New upstream release [February 2018] (Closes: #850753).
  * Restart on upgrade, like most daemons (Closes: #792327).
    Docker's upgrade tip from 17.12.0 release notes:
      "You must stop all containers and plugins BEFORE upgrading".
  * New multi-upstream-tarball (MUT) layout, building all docker components
    (containerd, libnetwork, swarmkit) at once;
    incorporated binaries of docker-containerd and libnetwork.
  * docker-dev to provide libnetwork-dev (a part of Docker).
  * New patches to build on go-1.10; build with latest Go compiler.
  * Declared myself as Maintainer.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 16 Jun 2018 20:05:48 +1000

docker.io (1.13.1~ds3-4) unstable; urgency=medium

  * Build with go-1.7 as later versions cause [archive,tarsum] failures
    (Closes: #901317).
  * Re-enabled [archive,tarsum] tests.
  * Build-Depends:
    = golang-1.7-go | golang-go (>= 2:1.6~)

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 12 Jun 2018 00:02:27 +1000

docker.io (1.13.1~ds3-3) unstable; urgency=medium

  * Removed invalid team email from Uploaders (Closes: #899285).
  * B-D: "libbtrfs-dev | btrfs-progs (<< 4.16.1~)" (Closes: #898876).
    Thanks, Dimitri John Ledkov.
  * (Build-)Depends:
    - removed unused "golang-github-aanand-compose-file-dev".
    - removed needless versioning and unknown alternatives.
  * dev: install "runconfig" (used by "github.com/aanand/compose-file").
  * repack.sh: use correct compression type, depending on file name.
  * watch file to version 4; updated "repack.sh".

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 10 Jun 2018 19:49:42 +1000

docker.io (1.13.1~ds3-2) unstable; urgency=medium

  * Team upload.
  * Install -dev files from build directory.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 09 Jun 2018 20:20:53 +1000

docker.io (1.13.1~ds3-1) unstable; urgency=medium

  * Team upload.

  [ Tianon Gravi ]
  * Remove gccgo support.
    Removed upstream in commit eda90f63446253f97d2011926555306f2417d208
    (https://github.com/moby/moby/pull/25978)
  * Update upstream-version-gitcommits with more upstream versions

  [ Dmitry Smirnov ]
  * New patch to fix CVE-2017-16539 (Closes: #900140).
  * New patch to remove 10 seconds delay on purge (Closes: #853258).
  * debhelper to version 11; compat to version 10.
  * copyright format URL to HTTPS; bump copyright years.
  * Standards-Version: 4.1.4.
  * Vcs URLs to Salsa.
  * Included "cliconfig" to -dev package (used by "gitlab-runner").
  * Included "reference" and "registry" into -dev package (used by "nomad").
  * Removed obsolete "golang-github-docker-engine-api-dev" from Build-Depends.
  * Use more private libraries to fix build and break circular dependencies:
    + github.com/docker/swarmkit
    + github.com/docker/libnetwork
    + github.com/docker/go-events
    + github.com/docker/go-metrics
  * Removed Upstart .conf file.
  * rules:
    + better clean, remove generated file(s).
    + fixed "sirupsen/logrus" imports.
    + DH_GOLANG_GO_GENERATE = 1

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 09 Jun 2018 14:50:13 +1000

docker.io (1.13.1~ds2-3) unstable; urgency=medium

  * Switch from "runc" to "docker-runc" and "containerd" to
    "docker-containerd", removing prefix-removing patch
    (Closes: #877329, #877892)
  * Update patches, especially test-disablers

 -- Tianon Gravi <tianon@debian.org>  Sat, 14 Oct 2017 08:58:11 -0700
